#include <stdio.h>

#include <X11/Xlib.h>
#include <X11/Intrinsic.h>
#include <X11/X.h>
#include <Xm/Xm.h>
#include <Xm/PushB.h>
#include <Xm/RowColumn.h>
#include <Xm/Text.h>
#include <Xm/TextF.h>
#include <Xm/MessageB.h>
#include <Xm/ScrolledW.h>
#include <Xm/ScrollBar.h>
#include <Xm/Frame.h>
#include <Xm/Label.h>
#include <Xm/Form.h>
#include <Xm/FileSB.h>
#include <Xm/Separator.h>
#include <Xm/List.h>

void quit_app_CB(Widget a_widget, XtPointer client_data, XtPointer call_data);
void set_Extended_CB(Widget a_widget, XtPointer client_data,
                     XtPointer call_data);
void set_Multiple_CB(Widget a_widget, XtPointer client_data,
                     XtPointer call_data);
void set_Single_CB(Widget a_widget, XtPointer client_data,
                   XtPointer call_data);
void toggle_Mode_CB(Widget a_widget, XtPointer client_data,
                    XtPointer call_data);
static void PropagateScrollCB( Widget w, XtPointer client_data,
                               XtPointer call_data );
static void PrepareScrollPropagationCB(Widget scrolledList,
                                       XtPointer client_data);
Widget gScrolled_list;
Boolean gSetMode_IsOn = False;

#define TURN_SET_MODE_ON_LBL "Turn SetMode On"
#define TURN_SET_MODE_OFF_LBL "Turn SetMode Off"

main(int argc, char *argv[])
{
  XmString *xm_str_array;
  Widget scrollBar;
  Widget toggleMode_pb;
  int num_items = 2000;
  Widget top_level_w, top_form, quit_b_w;
  Widget extend_pb, multi_pb, single_pb;
  int n1, i1, num_bits;
  Arg args[22];
  char char_string[128];
  XmString temp_xmstring;
  XtAppContext app_context;

  top_level_w = XtOpenApplication(&app_context, NULL, NULL, 0,
                  &argc, argv, NULL, topLevelShellWidgetClass,
                  NULL, 0);

  n1 = 0;
  top_form = XtCreateManagedWidget("top_form", xmFormWidgetClass,
                                    top_level_w, args, n1);

  temp_xmstring = XmStringCreateLtoR ("QUIT", XmFONTLIST_DEFAULT_TAG);
  n1 = 0;
  XtSetArg(args[n1], XmNlabelString, temp_xmstring);n1++;
  XtSetArg(args[n1], XmNleftAttachment, XmATTACH_FORM); n1++;
  XtSetArg(args[n1], XmNtopAttachment, XmATTACH_FORM); n1++;
  quit_b_w = XtCreateManagedWidget("quit_b_w", xmPushButtonWidgetClass,
                                   top_form, args, n1);
  XmStringFree (temp_xmstring);
  XtAddCallback(quit_b_w, XmNactivateCallback, quit_app_CB, NULL);

  temp_xmstring = XmStringCreateLtoR ("Set Extended", XmFONTLIST_DEFAULT_TAG);
  n1 = 0;
  XtSetArg(args[n1], XmNlabelString, temp_xmstring);n1++;
  XtSetArg(args[n1], XmNleftAttachment, XmATTACH_WIDGET); n1++;
  XtSetArg(args[n1], XmNleftWidget, quit_b_w); n1++;
  XtSetArg(args[n1], XmNtopAttachment, XmATTACH_FORM); n1++;
  extend_pb = XtCreateManagedWidget("extend_pb", xmPushButtonWidgetClass,
                                   top_form, args, n1);
  XmStringFree (temp_xmstring);
  XtAddCallback(extend_pb, XmNactivateCallback, set_Extended_CB, NULL);

  temp_xmstring = XmStringCreateLtoR ("Set Multiple", XmFONTLIST_DEFAULT_TAG);
  n1 = 0;
  XtSetArg(args[n1], XmNlabelString, temp_xmstring);n1++;
  XtSetArg(args[n1], XmNleftAttachment, XmATTACH_WIDGET); n1++;
  XtSetArg(args[n1], XmNleftWidget, extend_pb); n1++;
  XtSetArg(args[n1], XmNtopAttachment, XmATTACH_FORM); n1++;
  multi_pb = XtCreateManagedWidget("multi_pb", xmPushButtonWidgetClass,
                                   top_form, args, n1);
  XmStringFree (temp_xmstring);
  XtAddCallback(multi_pb, XmNactivateCallback, set_Multiple_CB, NULL);

  temp_xmstring = XmStringCreateLtoR ("Set Single", XmFONTLIST_DEFAULT_TAG);
  n1 = 0;
  XtSetArg(args[n1], XmNlabelString, temp_xmstring);n1++;
  XtSetArg(args[n1], XmNleftAttachment, XmATTACH_WIDGET); n1++;
  XtSetArg(args[n1], XmNleftWidget, multi_pb); n1++;
  XtSetArg(args[n1], XmNtopAttachment, XmATTACH_FORM); n1++;
  single_pb = XtCreateManagedWidget("single_pb", xmPushButtonWidgetClass,
                                   top_form, args, n1);
  XmStringFree (temp_xmstring);
  XtAddCallback(single_pb, XmNactivateCallback, set_Single_CB, NULL);

  temp_xmstring = XmStringCreateLtoR(TURN_SET_MODE_ON_LBL,
                                     XmFONTLIST_DEFAULT_TAG);
  n1 = 0;
  XtSetArg(args[n1], XmNlabelString, temp_xmstring);n1++;
  XtSetArg(args[n1], XmNleftAttachment, XmATTACH_WIDGET); n1++;
  XtSetArg(args[n1], XmNleftWidget, single_pb); n1++;
  XtSetArg(args[n1], XmNtopAttachment, XmATTACH_FORM); n1++;
  toggleMode_pb = XtCreateManagedWidget("toggleMode_pb", 
                                        xmPushButtonWidgetClass,
                                        top_form, args, n1);
  XmStringFree (temp_xmstring);
  XtAddCallback(toggleMode_pb, XmNactivateCallback, toggle_Mode_CB, NULL);

  n1 = 0;
  XtSetArg(args[n1], XmNrightAttachment, XmATTACH_FORM); n1++;
  XtSetArg(args[n1], XmNleftAttachment, XmATTACH_FORM); n1++;
  XtSetArg(args[n1], XmNtopAttachment, XmATTACH_WIDGET); n1++;
  XtSetArg(args[n1], XmNtopWidget, quit_b_w); n1++;

  XtSetArg(args[n1], XmNlistSizePolicy, XmCONSTANT); n1++;
  XtSetArg(args[n1], XmNscrollingPolicy, XmAPPLICATION_DEFINED); n1++;
  XtSetArg(args[n1], XmNscrollBarDisplayPolicy, XmSTATIC); n1++;
  XtSetArg(args[n1], XmNbottomAttachment, XmATTACH_FORM); n1++;
  XtSetArg(args[n1], XmNselectionPolicy, XmEXTENDED_SELECT); n1++;
  XtSetArg(args[n1], XmNvisibleItemCount, 20); n1++;
  gScrolled_list = XmCreateScrolledList(top_form, "gScrolled_list", 
                                        args, n1);
  XtManageChild(gScrolled_list);

  PrepareScrollPropagationCB(gScrolled_list, NULL);

  xm_str_array = (XmString*)XtCalloc(sizeof(XmString*), num_items);

  for(i1 = 0; i1 < num_items; i1++)
  {
    sprintf(char_string, "Item %d", i1);
    xm_str_array[i1] =
      XmStringCreateLtoR(char_string, XmFONTLIST_DEFAULT_TAG);
  }

  XtVaSetValues(gScrolled_list, XmNitems, xm_str_array, 
                XmNitemCount, num_items, NULL);

  for(i1 = 0; i1 < num_items; i1++)
  {
    XmStringFree(xm_str_array[i1]);
  }

  XtRealizeWidget(top_level_w);
  XtAppMainLoop(app_context);
}

void quit_app_CB(Widget a_widget, XtPointer client_data,
                 XtPointer call_data)
{
  XtCloseDisplay(XtDisplay(a_widget));
  exit(0);
}

void set_Extended_CB(Widget a_widget, XtPointer client_data,
                     XtPointer call_data)
{
  printf("Setting selection policy to XmEXTENDED_SELECT.\n");
  if(gSetMode_IsOn == True)
  {
    printf("XXX Setting XmNselectionMode to XmNORMAL_MODE.\n");
    XtVaSetValues(gScrolled_list,
                  XmNselectionMode, XmNORMAL_MODE,
                  XmNselectionPolicy, XmEXTENDED_SELECT, NULL);
  }
  else
  {
    printf("XXX NOT Setting XmNselectionMode.\n");
    XtVaSetValues(gScrolled_list,
                  XmNselectionPolicy, XmEXTENDED_SELECT, NULL);
  }

/*
  if(gSetMode_IsOn == True)
  {
    printf("XXX Setting XmListSetAddMode() to False.\n");
    XmListSetAddMode(gScrolled_list, False);
  }
*/
}

void set_Multiple_CB(Widget a_widget, XtPointer client_data,
                     XtPointer call_data)
{
  printf("Setting selection policy to XmMULTIPLE_SELECT.\n");
  XtVaSetValues(gScrolled_list,
                XmNselectionPolicy, XmMULTIPLE_SELECT, NULL);

  if(gSetMode_IsOn == True)
  {
/*
Commented out unnecessary code here.
    printf("XXX Setting XmListSetAddMode() to True.\n");
    XmListSetAddMode(gScrolled_list, True);
*/
  }
}

void set_Single_CB(Widget a_widget, XtPointer client_data,
                   XtPointer call_data)
{
  printf("Setting selection policy to XmSINGLE_SELECT.\n");
  XtVaSetValues(gScrolled_list,
                XmNselectionPolicy, XmSINGLE_SELECT, NULL);
  if(gSetMode_IsOn == True)
  {
/*
Commented out unnecessary code here.
    printf("XXX Setting XmListSetAddMode() to True.\n");
    XmListSetAddMode(gScrolled_list, True);
*/
  }
}

void toggle_Mode_CB(Widget pb_w, XtPointer client_data,
                    XtPointer call_data )
{
  XmString lbl_xmstr;
  char *ch_ptr;

  XtVaGetValues(pb_w,
                XmNlabelString, &lbl_xmstr, NULL);
  XmStringGetLtoR(lbl_xmstr, XmFONTLIST_DEFAULT_TAG, &ch_ptr);
  printf("ch_ptr: %s\n", ch_ptr);

  if(strcmp(ch_ptr, TURN_SET_MODE_ON_LBL) == 0)
  {
    printf("Turning Set Mode to True.\n");
    gSetMode_IsOn = True;
    lbl_xmstr = XmStringCreateLtoR(TURN_SET_MODE_OFF_LBL,
                                   XmFONTLIST_DEFAULT_TAG);
    XtVaSetValues(pb_w,
                  XmNlabelString, lbl_xmstr, NULL);
    XmStringFree(lbl_xmstr);
  }
  else
  {
    printf("Turning Set Mode to False.\n");
    gSetMode_IsOn = False;
    lbl_xmstr = XmStringCreateLtoR(TURN_SET_MODE_ON_LBL,
                                   XmFONTLIST_DEFAULT_TAG);
    XtVaSetValues(pb_w,
                  XmNlabelString, lbl_xmstr, NULL);
    XmStringFree(lbl_xmstr);
  }

}

static void PrepareScrollPropagationCB(Widget scrolledList,
                                       XtPointer client_data)
{
  Widget scrollBar;

  XtVaGetValues(XtParent(scrolledList), XmNverticalScrollBar, &scrollBar, NULL);

  XtAddCallback(scrollBar, XmNvalueChangedCallback,
                 (XtCallbackProc)PropagateScrollCB, (XtPointer)client_data);
  XtAddCallback(scrollBar, XmNdragCallback,
                 (XtCallbackProc)PropagateScrollCB, (XtPointer)client_data);
  XtAddCallback(scrollBar, XmNincrementCallback,
                 (XtCallbackProc)PropagateScrollCB, (XtPointer)client_data);
  XtAddCallback(scrollBar, XmNdecrementCallback,
                 (XtCallbackProc)PropagateScrollCB, (XtPointer)client_data);
  XtAddCallback(scrollBar, XmNpageIncrementCallback,
                 (XtCallbackProc)PropagateScrollCB, (XtPointer)client_data);
  XtAddCallback(scrollBar, XmNpageDecrementCallback,
                 (XtCallbackProc)PropagateScrollCB, (XtPointer)client_data);
  XtAddCallback(scrollBar, XmNtoTopCallback,
                 (XtCallbackProc)PropagateScrollCB, (XtPointer)client_data);
  XtAddCallback(scrollBar, XmNtoBottomCallback,
                 (XtCallbackProc)PropagateScrollCB, (XtPointer)client_data);

} /* End of function PrepareScrollPropagationCB() */

static void PropagateScrollCB( Widget w, XtPointer client_data,
                               XtPointer call_data )
{
  printf("In PropagateScrollCB()\n");
}


